// *** THIS FILE IS GENERATED - DO NOT EDIT ***
// See command_validation_generator.py for modifications

/***************************************************************************
*
* Copyright (c) 2021-2023 Valve Corporation
* Copyright (c) 2021-2023 LunarG, Inc.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
****************************************************************************/

// NOLINTBEGIN

#pragma once
#include <array>

// Used as key for maps of all vkCmd* calls
// Does not include vkBeginCommandBuffer/vkEndCommandBuffer
typedef enum CMD_TYPE {
    CMD_NONE = 0,
    CMD_BINDPIPELINE = 1,
    CMD_SETVIEWPORT = 2,
    CMD_SETSCISSOR = 3,
    CMD_SETLINEWIDTH = 4,
    CMD_SETDEPTHBIAS = 5,
    CMD_SETBLENDCONSTANTS = 6,
    CMD_SETDEPTHBOUNDS = 7,
    CMD_SETSTENCILCOMPAREMASK = 8,
    CMD_SETSTENCILWRITEMASK = 9,
    CMD_SETSTENCILREFERENCE = 10,
    CMD_BINDDESCRIPTORSETS = 11,
    CMD_BINDINDEXBUFFER = 12,
    CMD_BINDVERTEXBUFFERS = 13,
    CMD_DRAW = 14,
    CMD_DRAWINDEXED = 15,
    CMD_DRAWINDIRECT = 16,
    CMD_DRAWINDEXEDINDIRECT = 17,
    CMD_DISPATCH = 18,
    CMD_DISPATCHINDIRECT = 19,
    CMD_COPYBUFFER = 20,
    CMD_COPYIMAGE = 21,
    CMD_BLITIMAGE = 22,
    CMD_COPYBUFFERTOIMAGE = 23,
    CMD_COPYIMAGETOBUFFER = 24,
    CMD_UPDATEBUFFER = 25,
    CMD_FILLBUFFER = 26,
    CMD_CLEARCOLORIMAGE = 27,
    CMD_CLEARDEPTHSTENCILIMAGE = 28,
    CMD_CLEARATTACHMENTS = 29,
    CMD_RESOLVEIMAGE = 30,
    CMD_SETEVENT = 31,
    CMD_RESETEVENT = 32,
    CMD_WAITEVENTS = 33,
    CMD_PIPELINEBARRIER = 34,
    CMD_BEGINQUERY = 35,
    CMD_ENDQUERY = 36,
    CMD_RESETQUERYPOOL = 37,
    CMD_WRITETIMESTAMP = 38,
    CMD_COPYQUERYPOOLRESULTS = 39,
    CMD_PUSHCONSTANTS = 40,
    CMD_BEGINRENDERPASS = 41,
    CMD_NEXTSUBPASS = 42,
    CMD_ENDRENDERPASS = 43,
    CMD_EXECUTECOMMANDS = 44,
    CMD_SETDEVICEMASK = 45,
    CMD_DISPATCHBASE = 46,
    CMD_DRAWINDIRECTCOUNT = 47,
    CMD_DRAWINDEXEDINDIRECTCOUNT = 48,
    CMD_BEGINRENDERPASS2 = 49,
    CMD_NEXTSUBPASS2 = 50,
    CMD_ENDRENDERPASS2 = 51,
    CMD_SETEVENT2 = 52,
    CMD_RESETEVENT2 = 53,
    CMD_WAITEVENTS2 = 54,
    CMD_PIPELINEBARRIER2 = 55,
    CMD_WRITETIMESTAMP2 = 56,
    CMD_COPYBUFFER2 = 57,
    CMD_COPYIMAGE2 = 58,
    CMD_COPYBUFFERTOIMAGE2 = 59,
    CMD_COPYIMAGETOBUFFER2 = 60,
    CMD_BLITIMAGE2 = 61,
    CMD_RESOLVEIMAGE2 = 62,
    CMD_BEGINRENDERING = 63,
    CMD_ENDRENDERING = 64,
    CMD_SETCULLMODE = 65,
    CMD_SETFRONTFACE = 66,
    CMD_SETPRIMITIVETOPOLOGY = 67,
    CMD_SETVIEWPORTWITHCOUNT = 68,
    CMD_SETSCISSORWITHCOUNT = 69,
    CMD_BINDVERTEXBUFFERS2 = 70,
    CMD_SETDEPTHTESTENABLE = 71,
    CMD_SETDEPTHWRITEENABLE = 72,
    CMD_SETDEPTHCOMPAREOP = 73,
    CMD_SETDEPTHBOUNDSTESTENABLE = 74,
    CMD_SETSTENCILTESTENABLE = 75,
    CMD_SETSTENCILOP = 76,
    CMD_SETRASTERIZERDISCARDENABLE = 77,
    CMD_SETDEPTHBIASENABLE = 78,
    CMD_SETPRIMITIVERESTARTENABLE = 79,
    CMD_BEGINVIDEOCODINGKHR = 80,
    CMD_ENDVIDEOCODINGKHR = 81,
    CMD_CONTROLVIDEOCODINGKHR = 82,
    CMD_DECODEVIDEOKHR = 83,
    CMD_BEGINRENDERINGKHR = 84,
    CMD_ENDRENDERINGKHR = 85,
    CMD_SETDEVICEMASKKHR = 86,
    CMD_DISPATCHBASEKHR = 87,
    CMD_PUSHDESCRIPTORSETKHR = 88,
    CMD_PUSHDESCRIPTORSETWITHTEMPLATEKHR = 89,
    CMD_BEGINRENDERPASS2KHR = 90,
    CMD_NEXTSUBPASS2KHR = 91,
    CMD_ENDRENDERPASS2KHR = 92,
    CMD_DRAWINDIRECTCOUNTKHR = 93,
    CMD_DRAWINDEXEDINDIRECTCOUNTKHR = 94,
    CMD_SETFRAGMENTSHADINGRATEKHR = 95,
    CMD_ENCODEVIDEOKHR = 96,
    CMD_SETEVENT2KHR = 97,
    CMD_RESETEVENT2KHR = 98,
    CMD_WAITEVENTS2KHR = 99,
    CMD_PIPELINEBARRIER2KHR = 100,
    CMD_WRITETIMESTAMP2KHR = 101,
    CMD_WRITEBUFFERMARKER2AMD = 102,
    CMD_COPYBUFFER2KHR = 103,
    CMD_COPYIMAGE2KHR = 104,
    CMD_COPYBUFFERTOIMAGE2KHR = 105,
    CMD_COPYIMAGETOBUFFER2KHR = 106,
    CMD_BLITIMAGE2KHR = 107,
    CMD_RESOLVEIMAGE2KHR = 108,
    CMD_TRACERAYSINDIRECT2KHR = 109,
    CMD_BINDINDEXBUFFER2KHR = 110,
    CMD_DEBUGMARKERBEGINEXT = 111,
    CMD_DEBUGMARKERENDEXT = 112,
    CMD_DEBUGMARKERINSERTEXT = 113,
    CMD_BINDTRANSFORMFEEDBACKBUFFERSEXT = 114,
    CMD_BEGINTRANSFORMFEEDBACKEXT = 115,
    CMD_ENDTRANSFORMFEEDBACKEXT = 116,
    CMD_BEGINQUERYINDEXEDEXT = 117,
    CMD_ENDQUERYINDEXEDEXT = 118,
    CMD_DRAWINDIRECTBYTECOUNTEXT = 119,
    CMD_CULAUNCHKERNELNVX = 120,
    CMD_DRAWINDIRECTCOUNTAMD = 121,
    CMD_DRAWINDEXEDINDIRECTCOUNTAMD = 122,
    CMD_BEGINCONDITIONALRENDERINGEXT = 123,
    CMD_ENDCONDITIONALRENDERINGEXT = 124,
    CMD_SETVIEWPORTWSCALINGNV = 125,
    CMD_SETDISCARDRECTANGLEEXT = 126,
    CMD_SETDISCARDRECTANGLEENABLEEXT = 127,
    CMD_SETDISCARDRECTANGLEMODEEXT = 128,
    CMD_BEGINDEBUGUTILSLABELEXT = 129,
    CMD_ENDDEBUGUTILSLABELEXT = 130,
    CMD_INSERTDEBUGUTILSLABELEXT = 131,
    CMD_INITIALIZEGRAPHSCRATCHMEMORYAMDX = 132,
    CMD_DISPATCHGRAPHAMDX = 133,
    CMD_DISPATCHGRAPHINDIRECTAMDX = 134,
    CMD_DISPATCHGRAPHINDIRECTCOUNTAMDX = 135,
    CMD_SETSAMPLELOCATIONSEXT = 136,
    CMD_BINDSHADINGRATEIMAGENV = 137,
    CMD_SETVIEWPORTSHADINGRATEPALETTENV = 138,
    CMD_SETCOARSESAMPLEORDERNV = 139,
    CMD_BUILDACCELERATIONSTRUCTURENV = 140,
    CMD_COPYACCELERATIONSTRUCTURENV = 141,
    CMD_TRACERAYSNV = 142,
    CMD_WRITEACCELERATIONSTRUCTURESPROPERTIESNV = 143,
    CMD_WRITEBUFFERMARKERAMD = 144,
    CMD_DRAWMESHTASKSNV = 145,
    CMD_DRAWMESHTASKSINDIRECTNV = 146,
    CMD_DRAWMESHTASKSINDIRECTCOUNTNV = 147,
    CMD_SETEXCLUSIVESCISSORENABLENV = 148,
    CMD_SETEXCLUSIVESCISSORNV = 149,
    CMD_SETCHECKPOINTNV = 150,
    CMD_SETPERFORMANCEMARKERINTEL = 151,
    CMD_SETPERFORMANCESTREAMMARKERINTEL = 152,
    CMD_SETPERFORMANCEOVERRIDEINTEL = 153,
    CMD_SETLINESTIPPLEEXT = 154,
    CMD_SETCULLMODEEXT = 155,
    CMD_SETFRONTFACEEXT = 156,
    CMD_SETPRIMITIVETOPOLOGYEXT = 157,
    CMD_SETVIEWPORTWITHCOUNTEXT = 158,
    CMD_SETSCISSORWITHCOUNTEXT = 159,
    CMD_BINDVERTEXBUFFERS2EXT = 160,
    CMD_SETDEPTHTESTENABLEEXT = 161,
    CMD_SETDEPTHWRITEENABLEEXT = 162,
    CMD_SETDEPTHCOMPAREOPEXT = 163,
    CMD_SETDEPTHBOUNDSTESTENABLEEXT = 164,
    CMD_SETSTENCILTESTENABLEEXT = 165,
    CMD_SETSTENCILOPEXT = 166,
    CMD_PREPROCESSGENERATEDCOMMANDSNV = 167,
    CMD_EXECUTEGENERATEDCOMMANDSNV = 168,
    CMD_BINDPIPELINESHADERGROUPNV = 169,
    CMD_SETDEPTHBIAS2EXT = 170,
    CMD_BINDDESCRIPTORBUFFERSEXT = 171,
    CMD_SETDESCRIPTORBUFFEROFFSETSEXT = 172,
    CMD_BINDDESCRIPTORBUFFEREMBEDDEDSAMPLERSEXT = 173,
    CMD_SETFRAGMENTSHADINGRATEENUMNV = 174,
    CMD_SETVERTEXINPUTEXT = 175,
    CMD_SUBPASSSHADINGHUAWEI = 176,
    CMD_BINDINVOCATIONMASKHUAWEI = 177,
    CMD_SETPATCHCONTROLPOINTSEXT = 178,
    CMD_SETRASTERIZERDISCARDENABLEEXT = 179,
    CMD_SETDEPTHBIASENABLEEXT = 180,
    CMD_SETLOGICOPEXT = 181,
    CMD_SETPRIMITIVERESTARTENABLEEXT = 182,
    CMD_SETCOLORWRITEENABLEEXT = 183,
    CMD_DRAWMULTIEXT = 184,
    CMD_DRAWMULTIINDEXEDEXT = 185,
    CMD_BUILDMICROMAPSEXT = 186,
    CMD_COPYMICROMAPEXT = 187,
    CMD_COPYMICROMAPTOMEMORYEXT = 188,
    CMD_COPYMEMORYTOMICROMAPEXT = 189,
    CMD_WRITEMICROMAPSPROPERTIESEXT = 190,
    CMD_DRAWCLUSTERHUAWEI = 191,
    CMD_DRAWCLUSTERINDIRECTHUAWEI = 192,
    CMD_COPYMEMORYINDIRECTNV = 193,
    CMD_COPYMEMORYTOIMAGEINDIRECTNV = 194,
    CMD_DECOMPRESSMEMORYNV = 195,
    CMD_DECOMPRESSMEMORYINDIRECTCOUNTNV = 196,
    CMD_UPDATEPIPELINEINDIRECTBUFFERNV = 197,
    CMD_SETTESSELLATIONDOMAINORIGINEXT = 198,
    CMD_SETDEPTHCLAMPENABLEEXT = 199,
    CMD_SETPOLYGONMODEEXT = 200,
    CMD_SETRASTERIZATIONSAMPLESEXT = 201,
    CMD_SETSAMPLEMASKEXT = 202,
    CMD_SETALPHATOCOVERAGEENABLEEXT = 203,
    CMD_SETALPHATOONEENABLEEXT = 204,
    CMD_SETLOGICOPENABLEEXT = 205,
    CMD_SETCOLORBLENDENABLEEXT = 206,
    CMD_SETCOLORBLENDEQUATIONEXT = 207,
    CMD_SETCOLORWRITEMASKEXT = 208,
    CMD_SETRASTERIZATIONSTREAMEXT = 209,
    CMD_SETCONSERVATIVERASTERIZATIONMODEEXT = 210,
    CMD_SETEXTRAPRIMITIVEOVERESTIMATIONSIZEEXT = 211,
    CMD_SETDEPTHCLIPENABLEEXT = 212,
    CMD_SETSAMPLELOCATIONSENABLEEXT = 213,
    CMD_SETCOLORBLENDADVANCEDEXT = 214,
    CMD_SETPROVOKINGVERTEXMODEEXT = 215,
    CMD_SETLINERASTERIZATIONMODEEXT = 216,
    CMD_SETLINESTIPPLEENABLEEXT = 217,
    CMD_SETDEPTHCLIPNEGATIVEONETOONEEXT = 218,
    CMD_SETVIEWPORTWSCALINGENABLENV = 219,
    CMD_SETVIEWPORTSWIZZLENV = 220,
    CMD_SETCOVERAGETOCOLORENABLENV = 221,
    CMD_SETCOVERAGETOCOLORLOCATIONNV = 222,
    CMD_SETCOVERAGEMODULATIONMODENV = 223,
    CMD_SETCOVERAGEMODULATIONTABLEENABLENV = 224,
    CMD_SETCOVERAGEMODULATIONTABLENV = 225,
    CMD_SETSHADINGRATEIMAGEENABLENV = 226,
    CMD_SETREPRESENTATIVEFRAGMENTTESTENABLENV = 227,
    CMD_SETCOVERAGEREDUCTIONMODENV = 228,
    CMD_OPTICALFLOWEXECUTENV = 229,
    CMD_BINDSHADERSEXT = 230,
    CMD_SETATTACHMENTFEEDBACKLOOPENABLEEXT = 231,
    CMD_BUILDACCELERATIONSTRUCTURESKHR = 232,
    CMD_BUILDACCELERATIONSTRUCTURESINDIRECTKHR = 233,
    CMD_COPYACCELERATIONSTRUCTUREKHR = 234,
    CMD_COPYACCELERATIONSTRUCTURETOMEMORYKHR = 235,
    CMD_COPYMEMORYTOACCELERATIONSTRUCTUREKHR = 236,
    CMD_WRITEACCELERATIONSTRUCTURESPROPERTIESKHR = 237,
    CMD_TRACERAYSKHR = 238,
    CMD_TRACERAYSINDIRECTKHR = 239,
    CMD_SETRAYTRACINGPIPELINESTACKSIZEKHR = 240,
    CMD_DRAWMESHTASKSEXT = 241,
    CMD_DRAWMESHTASKSINDIRECTEXT = 242,
    CMD_DRAWMESHTASKSINDIRECTCOUNTEXT = 243,
    CMD_RANGE_SIZE = 244
} CMD_TYPE;

static const std::array<const char *, CMD_RANGE_SIZE> kGeneratedCommandNameList = {{
    "Command_Undefined",
    "vkCmdBindPipeline",
    "vkCmdSetViewport",
    "vkCmdSetScissor",
    "vkCmdSetLineWidth",
    "vkCmdSetDepthBias",
    "vkCmdSetBlendConstants",
    "vkCmdSetDepthBounds",
    "vkCmdSetStencilCompareMask",
    "vkCmdSetStencilWriteMask",
    "vkCmdSetStencilReference",
    "vkCmdBindDescriptorSets",
    "vkCmdBindIndexBuffer",
    "vkCmdBindVertexBuffers",
    "vkCmdDraw",
    "vkCmdDrawIndexed",
    "vkCmdDrawIndirect",
    "vkCmdDrawIndexedIndirect",
    "vkCmdDispatch",
    "vkCmdDispatchIndirect",
    "vkCmdCopyBuffer",
    "vkCmdCopyImage",
    "vkCmdBlitImage",
    "vkCmdCopyBufferToImage",
    "vkCmdCopyImageToBuffer",
    "vkCmdUpdateBuffer",
    "vkCmdFillBuffer",
    "vkCmdClearColorImage",
    "vkCmdClearDepthStencilImage",
    "vkCmdClearAttachments",
    "vkCmdResolveImage",
    "vkCmdSetEvent",
    "vkCmdResetEvent",
    "vkCmdWaitEvents",
    "vkCmdPipelineBarrier",
    "vkCmdBeginQuery",
    "vkCmdEndQuery",
    "vkCmdResetQueryPool",
    "vkCmdWriteTimestamp",
    "vkCmdCopyQueryPoolResults",
    "vkCmdPushConstants",
    "vkCmdBeginRenderPass",
    "vkCmdNextSubpass",
    "vkCmdEndRenderPass",
    "vkCmdExecuteCommands",
    "vkCmdSetDeviceMask",
    "vkCmdDispatchBase",
    "vkCmdDrawIndirectCount",
    "vkCmdDrawIndexedIndirectCount",
    "vkCmdBeginRenderPass2",
    "vkCmdNextSubpass2",
    "vkCmdEndRenderPass2",
    "vkCmdSetEvent2",
    "vkCmdResetEvent2",
    "vkCmdWaitEvents2",
    "vkCmdPipelineBarrier2",
    "vkCmdWriteTimestamp2",
    "vkCmdCopyBuffer2",
    "vkCmdCopyImage2",
    "vkCmdCopyBufferToImage2",
    "vkCmdCopyImageToBuffer2",
    "vkCmdBlitImage2",
    "vkCmdResolveImage2",
    "vkCmdBeginRendering",
    "vkCmdEndRendering",
    "vkCmdSetCullMode",
    "vkCmdSetFrontFace",
    "vkCmdSetPrimitiveTopology",
    "vkCmdSetViewportWithCount",
    "vkCmdSetScissorWithCount",
    "vkCmdBindVertexBuffers2",
    "vkCmdSetDepthTestEnable",
    "vkCmdSetDepthWriteEnable",
    "vkCmdSetDepthCompareOp",
    "vkCmdSetDepthBoundsTestEnable",
    "vkCmdSetStencilTestEnable",
    "vkCmdSetStencilOp",
    "vkCmdSetRasterizerDiscardEnable",
    "vkCmdSetDepthBiasEnable",
    "vkCmdSetPrimitiveRestartEnable",
    "vkCmdBeginVideoCodingKHR",
    "vkCmdEndVideoCodingKHR",
    "vkCmdControlVideoCodingKHR",
    "vkCmdDecodeVideoKHR",
    "vkCmdBeginRenderingKHR",
    "vkCmdEndRenderingKHR",
    "vkCmdSetDeviceMaskKHR",
    "vkCmdDispatchBaseKHR",
    "vkCmdPushDescriptorSetKHR",
    "vkCmdPushDescriptorSetWithTemplateKHR",
    "vkCmdBeginRenderPass2KHR",
    "vkCmdNextSubpass2KHR",
    "vkCmdEndRenderPass2KHR",
    "vkCmdDrawIndirectCountKHR",
    "vkCmdDrawIndexedIndirectCountKHR",
    "vkCmdSetFragmentShadingRateKHR",
    "vkCmdEncodeVideoKHR",
    "vkCmdSetEvent2KHR",
    "vkCmdResetEvent2KHR",
    "vkCmdWaitEvents2KHR",
    "vkCmdPipelineBarrier2KHR",
    "vkCmdWriteTimestamp2KHR",
    "vkCmdWriteBufferMarker2AMD",
    "vkCmdCopyBuffer2KHR",
    "vkCmdCopyImage2KHR",
    "vkCmdCopyBufferToImage2KHR",
    "vkCmdCopyImageToBuffer2KHR",
    "vkCmdBlitImage2KHR",
    "vkCmdResolveImage2KHR",
    "vkCmdTraceRaysIndirect2KHR",
    "vkCmdBindIndexBuffer2KHR",
    "vkCmdDebugMarkerBeginEXT",
    "vkCmdDebugMarkerEndEXT",
    "vkCmdDebugMarkerInsertEXT",
    "vkCmdBindTransformFeedbackBuffersEXT",
    "vkCmdBeginTransformFeedbackEXT",
    "vkCmdEndTransformFeedbackEXT",
    "vkCmdBeginQueryIndexedEXT",
    "vkCmdEndQueryIndexedEXT",
    "vkCmdDrawIndirectByteCountEXT",
    "vkCmdCuLaunchKernelNVX",
    "vkCmdDrawIndirectCountAMD",
    "vkCmdDrawIndexedIndirectCountAMD",
    "vkCmdBeginConditionalRenderingEXT",
    "vkCmdEndConditionalRenderingEXT",
    "vkCmdSetViewportWScalingNV",
    "vkCmdSetDiscardRectangleEXT",
    "vkCmdSetDiscardRectangleEnableEXT",
    "vkCmdSetDiscardRectangleModeEXT",
    "vkCmdBeginDebugUtilsLabelEXT",
    "vkCmdEndDebugUtilsLabelEXT",
    "vkCmdInsertDebugUtilsLabelEXT",
    "vkCmdInitializeGraphScratchMemoryAMDX",
    "vkCmdDispatchGraphAMDX",
    "vkCmdDispatchGraphIndirectAMDX",
    "vkCmdDispatchGraphIndirectCountAMDX",
    "vkCmdSetSampleLocationsEXT",
    "vkCmdBindShadingRateImageNV",
    "vkCmdSetViewportShadingRatePaletteNV",
    "vkCmdSetCoarseSampleOrderNV",
    "vkCmdBuildAccelerationStructureNV",
    "vkCmdCopyAccelerationStructureNV",
    "vkCmdTraceRaysNV",
    "vkCmdWriteAccelerationStructuresPropertiesNV",
    "vkCmdWriteBufferMarkerAMD",
    "vkCmdDrawMeshTasksNV",
    "vkCmdDrawMeshTasksIndirectNV",
    "vkCmdDrawMeshTasksIndirectCountNV",
    "vkCmdSetExclusiveScissorEnableNV",
    "vkCmdSetExclusiveScissorNV",
    "vkCmdSetCheckpointNV",
    "vkCmdSetPerformanceMarkerINTEL",
    "vkCmdSetPerformanceStreamMarkerINTEL",
    "vkCmdSetPerformanceOverrideINTEL",
    "vkCmdSetLineStippleEXT",
    "vkCmdSetCullModeEXT",
    "vkCmdSetFrontFaceEXT",
    "vkCmdSetPrimitiveTopologyEXT",
    "vkCmdSetViewportWithCountEXT",
    "vkCmdSetScissorWithCountEXT",
    "vkCmdBindVertexBuffers2EXT",
    "vkCmdSetDepthTestEnableEXT",
    "vkCmdSetDepthWriteEnableEXT",
    "vkCmdSetDepthCompareOpEXT",
    "vkCmdSetDepthBoundsTestEnableEXT",
    "vkCmdSetStencilTestEnableEXT",
    "vkCmdSetStencilOpEXT",
    "vkCmdPreprocessGeneratedCommandsNV",
    "vkCmdExecuteGeneratedCommandsNV",
    "vkCmdBindPipelineShaderGroupNV",
    "vkCmdSetDepthBias2EXT",
    "vkCmdBindDescriptorBuffersEXT",
    "vkCmdSetDescriptorBufferOffsetsEXT",
    "vkCmdBindDescriptorBufferEmbeddedSamplersEXT",
    "vkCmdSetFragmentShadingRateEnumNV",
    "vkCmdSetVertexInputEXT",
    "vkCmdSubpassShadingHUAWEI",
    "vkCmdBindInvocationMaskHUAWEI",
    "vkCmdSetPatchControlPointsEXT",
    "vkCmdSetRasterizerDiscardEnableEXT",
    "vkCmdSetDepthBiasEnableEXT",
    "vkCmdSetLogicOpEXT",
    "vkCmdSetPrimitiveRestartEnableEXT",
    "vkCmdSetColorWriteEnableEXT",
    "vkCmdDrawMultiEXT",
    "vkCmdDrawMultiIndexedEXT",
    "vkCmdBuildMicromapsEXT",
    "vkCmdCopyMicromapEXT",
    "vkCmdCopyMicromapToMemoryEXT",
    "vkCmdCopyMemoryToMicromapEXT",
    "vkCmdWriteMicromapsPropertiesEXT",
    "vkCmdDrawClusterHUAWEI",
    "vkCmdDrawClusterIndirectHUAWEI",
    "vkCmdCopyMemoryIndirectNV",
    "vkCmdCopyMemoryToImageIndirectNV",
    "vkCmdDecompressMemoryNV",
    "vkCmdDecompressMemoryIndirectCountNV",
    "vkCmdUpdatePipelineIndirectBufferNV",
    "vkCmdSetTessellationDomainOriginEXT",
    "vkCmdSetDepthClampEnableEXT",
    "vkCmdSetPolygonModeEXT",
    "vkCmdSetRasterizationSamplesEXT",
    "vkCmdSetSampleMaskEXT",
    "vkCmdSetAlphaToCoverageEnableEXT",
    "vkCmdSetAlphaToOneEnableEXT",
    "vkCmdSetLogicOpEnableEXT",
    "vkCmdSetColorBlendEnableEXT",
    "vkCmdSetColorBlendEquationEXT",
    "vkCmdSetColorWriteMaskEXT",
    "vkCmdSetRasterizationStreamEXT",
    "vkCmdSetConservativeRasterizationModeEXT",
    "vkCmdSetExtraPrimitiveOverestimationSizeEXT",
    "vkCmdSetDepthClipEnableEXT",
    "vkCmdSetSampleLocationsEnableEXT",
    "vkCmdSetColorBlendAdvancedEXT",
    "vkCmdSetProvokingVertexModeEXT",
    "vkCmdSetLineRasterizationModeEXT",
    "vkCmdSetLineStippleEnableEXT",
    "vkCmdSetDepthClipNegativeOneToOneEXT",
    "vkCmdSetViewportWScalingEnableNV",
    "vkCmdSetViewportSwizzleNV",
    "vkCmdSetCoverageToColorEnableNV",
    "vkCmdSetCoverageToColorLocationNV",
    "vkCmdSetCoverageModulationModeNV",
    "vkCmdSetCoverageModulationTableEnableNV",
    "vkCmdSetCoverageModulationTableNV",
    "vkCmdSetShadingRateImageEnableNV",
    "vkCmdSetRepresentativeFragmentTestEnableNV",
    "vkCmdSetCoverageReductionModeNV",
    "vkCmdOpticalFlowExecuteNV",
    "vkCmdBindShadersEXT",
    "vkCmdSetAttachmentFeedbackLoopEnableEXT",
    "vkCmdBuildAccelerationStructuresKHR",
    "vkCmdBuildAccelerationStructuresIndirectKHR",
    "vkCmdCopyAccelerationStructureKHR",
    "vkCmdCopyAccelerationStructureToMemoryKHR",
    "vkCmdCopyMemoryToAccelerationStructureKHR",
    "vkCmdWriteAccelerationStructuresPropertiesKHR",
    "vkCmdTraceRaysKHR",
    "vkCmdTraceRaysIndirectKHR",
    "vkCmdSetRayTracingPipelineStackSizeKHR",
    "vkCmdDrawMeshTasksEXT",
    "vkCmdDrawMeshTasksIndirectEXT",
    "vkCmdDrawMeshTasksIndirectCountEXT",
}};
// NOLINTEND
